// test_countme.cpp
// Glenn G. Chappell
// 24 Sep 2013
//
// For CS 202 Fall 2013
// Test program for class CountMe

#include "countme.h"  // For class CountMe
#include "countme.h"  // Double-inclusion test

#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <vector>
using std::vector;


bool allGood = true;  // true if all tests pass so far


// testCountMe1
// Test #1 for class CountMe
// Prints results of tests, sets global allGood to false if any fail
void testCountMe1()
{
    cout << endl;
    cout << "Test 1" << endl;
    int hm;  // Stores return value of howMany

    hm = howMany();
    cout << "Number of CountMe objects (should be 0): " << hm << endl;
    if (hm != 0)
    {
        allGood = false;
    }

    {
        cout << "Constructing CountMe object" << endl;
        const CountMe c1;
        hm = howMany();
        cout << "Number of CountMe objects (should be 1): " << hm << endl;
        if (hm != 1)
        {
            allGood = false;
        }
        cout << "Destroying CountMe object" << endl;
    }

    hm = howMany();
    cout << "Number of CountMe objects (should be 0): " << hm << endl;
    if (hm != 0)
    {
        allGood = false;
    }

    cout << "Constructing 5 CountMe objects" << endl;
    const CountMe c2, c3, c4, c5, c6;
    hm = howMany();
    cout << "Number of CountMe objects (should be 5): " << hm << endl;
    if (hm != 5)
    {
        allGood = false;
    }

    cout << "Constructing 6 CountMe objects" << endl;
    const CountMe c7, c8, c9, c10, c11, c12;
    hm = howMany();
    cout << "Number of CountMe objects (should be 11): " << hm << endl;
    if (hm != 11)
    {
        allGood = false;
    }

    cout << "Destroying all CountMe objects" << endl;
}


// testCountMe2
// Test #2 for class CountMe
// Prints results of tests, sets global allGood to false if any fail
void testCountMe2()
{
    cout << endl;
    cout << "Test 2" << endl;
    int hm;  // Stores return value of howMany

    hm = howMany();
    cout << "Number of CountMe objects (should be 0): " << hm << endl;
    if (hm != 0)
    {
        allGood = false;
    }

    {
        cout << "Constructing 10000 CountMe objects" << endl;;
        vector<CountMe> vc(10000);
        hm = howMany();
        cout << "Number of CountMe objects (should be 10000): " << hm << endl;
        if (hm != 10000)
        {
            allGood = false;
        }
        cout << "Destroying 10000 CountMe objects" << endl;
    }

    hm = howMany();
    cout << "Number of CountMe objects (should be 0): " << hm << endl;
    if (hm != 0)
    {
        allGood = false;
    }
}


// main program
// Runs tests for class CountMe, prints results
int main()
{
    testCountMe1();
    testCountMe2();
    
    cout << endl;
    if (allGood)
        cout << "All tests pass!" << endl;
    else
        cout << "***** SOME TESTS FAILED *****" << endl;

    cout << endl;
    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

